function numericLoad()
{
  var builder = document.getElementById("@mozdev.org/urlnav/builder;1?type=num").component;
  var min = document.getElementById("numMinText");
  var max = document.getElementById("numMaxText");
  var step = document.getElementById("numStepText");
  var trim = document.getElementById("numCheckTrim");
  
  min.setAttribute("value", String(builder.properties.getProperty("min")));
  max.setAttribute("value", String(builder.properties.getProperty("max")));
  step.setAttribute("value", String(builder.properties.getProperty("step")));
  trim.setAttribute("checked", (builder.properties.getProperty("trim"))? "true": "false");  
};

function numericAccept()
{
  //only test if we are the builder
  var contract = gCapture.list.selectedItem.getAttribute("id");
  if (contract != "@mozdev.org/urlnav/builder;1?type=num")
    return true;   
  
  //get prompt service   
  var sbs = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);    
  var bundle = sbs.createBundle("chrome://urlnav/locale/urlnav.properties");
  var ps = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);         
  
  //test values
  var min = document.getElementById("numMinText").value.replace(/^\s*|\s*$/g,"");
  var max = document.getElementById("numMaxText").value.replace(/^\s*|\s*$/g,"");
  var step = document.getElementById("numStepText").value.replace(/^\s*|\s*$/g,"");
  var trim = document.getElementById("numCheckTrim").checked;
  min = Number(min);
  max = Number(max);
  step = Number(step);
  
  if (isNaN(min)) {
    ps.alert(window, bundle.GetStringFromName("urlnav.error.title"), bundle.GetStringFromName("urlnav.builder.num.min"));
    return false;
  };
  if (isNaN(max)) {
    ps.alert(window, bundle.GetStringFromName("urlnav.error.title"), bundle.GetStringFromName("urlnav.builder.num.max"));
    return false;
  };
  if (isNaN(step)) {
    ps.alert(window, bundle.GetStringFromName("urlnav.error.title"), bundle.GetStringFromName("urlnav.builder.num.step"));
    return false;
  };
      
  //update builder
  var builder = gCapture.list.selectedItem.component;
  builder.properties.setProperty("min", min);
  builder.properties.setProperty("max", max);
  builder.properties.setProperty("step", step);
  builder.properties.setProperty("trim", trim);
  return true;
};

gCapture.registerCallback("load", numericLoad);
gCapture.registerCallback("accept", numericAccept);